#include "stdint.h"
#include "arduino_dds.h"

Ext_arduino_dds_S arduino_dds_S;

typedef struct AnalogInput_Amp_cfunc_symbols_t {
	double amplitude;
} AnalogInput_Amp_cfunc_symbols_t;

typedef struct AnalogInput_Amp_cfunc_params_t {
	bool _;
} AnalogInput_Amp_cfunc_params_t;

AnalogInput_Amp_cfunc_params_t AnalogInput_Amp_cfunc_params = {
	false
};

static void AnalogInput_Amp_cfunc_init() {

}
static void AnalogInput_Amp_cfunc(AnalogInput_Amp_cfunc_symbols_t * cfunc_symbols, AnalogInput_Amp_cfunc_params_t * cfunc_params) {
	double amplitude;
	#ifdef Arduino_h
	    amplitude = analogRead(A1) / 1023.0; // Получение значения амплитуды от аналогового порта
	#else
	    amplitude = 1.0;
	#endif
	cfunc_symbols->amplitude = amplitude;
}

static void AnalogInput_Amp_cfunc_term() {

}
typedef struct AnalogInput_Freq_cfunc_symbols_t {
	double frequency;
} AnalogInput_Freq_cfunc_symbols_t;

typedef struct AnalogInput_Freq_cfunc_params_t {
	bool _;
} AnalogInput_Freq_cfunc_params_t;

AnalogInput_Freq_cfunc_params_t AnalogInput_Freq_cfunc_params = {
	false
};

static void AnalogInput_Freq_cfunc_init() {

}
static void AnalogInput_Freq_cfunc(AnalogInput_Freq_cfunc_symbols_t * cfunc_symbols, AnalogInput_Freq_cfunc_params_t * cfunc_params) {
	double frequency;
	#ifdef Arduino_h
	    frequency = analogRead(A0)/1023.0; // Получение значения громкости от аналогового порта
	#else
	    frequency = 0.5;
	#endif
	cfunc_symbols->frequency = frequency;
}

static void AnalogInput_Freq_cfunc_term() {

}
typedef struct DigitalInput_Mode_cfunc_symbols_t {
	double PinState;
} DigitalInput_Mode_cfunc_symbols_t;

typedef struct DigitalInput_Mode_cfunc_params_t {
	bool _;
} DigitalInput_Mode_cfunc_params_t;

DigitalInput_Mode_cfunc_params_t DigitalInput_Mode_cfunc_params = {
	false
};

static void DigitalInput_Mode_cfunc_init() {
	#ifdef Arduino_h
	    pinMode(ModePin, INPUT); // инициализация порта ModePin в качестве входа
	#endif
}
static void DigitalInput_Mode_cfunc(DigitalInput_Mode_cfunc_symbols_t * cfunc_symbols, DigitalInput_Mode_cfunc_params_t * cfunc_params) {
	double PinState;
	#ifdef Arduino_h
	      PinState = digitalRead(ModePin); // считывание состояния входа выбора режима светофора ModePin
	#else 
	      PinState++;       // Инкремент выходного значения
	      if(PinState >= 1620) PinState = -10;   // Сброс выходного значения - подача заднего фронта
	#endif
	cfunc_symbols->PinState = PinState;
}

static void DigitalInput_Mode_cfunc_term() {

}
typedef struct HRPWM_Output_cfunc_symbols_t {
	double OutValue;
} HRPWM_Output_cfunc_symbols_t;

typedef struct HRPWM_Output_cfunc_params_t {
	bool _;
} HRPWM_Output_cfunc_params_t;

HRPWM_Output_cfunc_params_t HRPWM_Output_cfunc_params = {
	false
};

static void HRPWM_Output_cfunc_init() {
	#ifdef Arduino_h
	    PWM_Instance = new AVR_PWM(pinToUse, 100.0f, 50); // Установка режима работы модуля ШИМ
	
	    if (PWM_Instance) {
	        if (!PWM_Instance->setPWM()) {
	            Serial.begin(9600);
	            Serial.println(F("Stop here"));
	            // stop here
	            while (true)
	            delay(1000);
	            }
	    }
	#endif
}
static void HRPWM_Output_cfunc(HRPWM_Output_cfunc_symbols_t * cfunc_symbols, HRPWM_Output_cfunc_params_t * cfunc_params) {
	double OutValue = cfunc_symbols->OutValue;
	#ifdef Arduino_h
	      OCR2B = OutValue; // Изменение скважности ШИМ
	#endif
}

static void HRPWM_Output_cfunc_term() {

}
void arduino_dds_init() {
	AnalogInput_Amp_cfunc_init();
	AnalogInput_Freq_cfunc_init();
	DigitalInput_Mode_cfunc_init();
	arduino_dds_S.UnitDelay_state = 0.0;
	arduino_dds_S.UnitDelay_1_state = 0.0;
	arduino_dds_S.UnitDelay_1_1_state = 0.0;
	arduino_dds_S.previos_state = 0.0;
	arduino_dds_S.UnitDelay_2_state = 0.0;
	arduino_dds_S.UnitDelay_3_state = 0.0;
	arduino_dds_S.counter_state = 0.0;
	arduino_dds_S.direction_state = false;
	HRPWM_Output_cfunc_init();
}

void arduino_dds_term() {
	AnalogInput_Amp_cfunc_term();
	AnalogInput_Freq_cfunc_term();
	DigitalInput_Mode_cfunc_term();
	HRPWM_Output_cfunc_term();
}

void arduino_dds_step() {
	double radian;
	double UnitDelay;
	double UnitDelay_1;
	double UnitDelay_1_1;
	bool previos;
	double UnitDelay_2;
	double UnitDelay_3;
	double counter;
	double scale;
	double scale_1;
	double accumulation;
	double accumulation_1;
	double accumulation_2;
	double Add_1;
	double wt;
	bool Compare;
	bool Compare_1;
	bool Compare_2;
	bool Compare_3;
	bool Compare_4;
	double sinus;
	bool rising;
	double offset;
	double amplitude;
	double accumulation_3;
	bool duty;
	double direction;
	double down;
	double Add;
	bool Compare_5;
	double change;
	double MultiportSwitch;

	UnitDelay = arduino_dds_S.UnitDelay_state;
	UnitDelay_1 = arduino_dds_S.UnitDelay_1_state;
	UnitDelay_1_1 = arduino_dds_S.UnitDelay_1_1_state;
	previos = arduino_dds_S.previos_state;
	UnitDelay_2 = arduino_dds_S.UnitDelay_2_state;
	UnitDelay_3 = arduino_dds_S.UnitDelay_3_state;
	AnalogInput_Amp_cfunc_symbols_t AnalogInput_Amp_cfunc_symbols = {
	};
	AnalogInput_Amp_cfunc(&AnalogInput_Amp_cfunc_symbols, &AnalogInput_Amp_cfunc_params);
	AnalogInput_Freq_cfunc_symbols_t AnalogInput_Freq_cfunc_symbols = {
	};
	AnalogInput_Freq_cfunc(&AnalogInput_Freq_cfunc_symbols, &AnalogInput_Freq_cfunc_params);
	DigitalInput_Mode_cfunc_symbols_t DigitalInput_Mode_cfunc_symbols = {
	};
	DigitalInput_Mode_cfunc(&DigitalInput_Mode_cfunc_symbols, &DigitalInput_Mode_cfunc_params);
	radian = 314.15 * 1.0;
	counter = arduino_dds_S.counter_state;
	scale = 16 * AnalogInput_Amp_cfunc_symbols.amplitude;
	scale_1 = 32.0 * AnalogInput_Amp_cfunc_symbols.amplitude;
	accumulation = AnalogInput_Freq_cfunc_symbols.frequency + UnitDelay_1_1;
	accumulation_1 = AnalogInput_Freq_cfunc_symbols.frequency + UnitDelay;
	accumulation_2 = AnalogInput_Freq_cfunc_symbols.frequency + UnitDelay_2;
	Add_1 = AnalogInput_Freq_cfunc_symbols.frequency + UnitDelay_3;
	wt = radian * counter;
	Compare = DigitalInput_Mode_cfunc_symbols.PinState <= 0;
	Compare_1 = accumulation_1 <= 64.0;
	Compare_2 = accumulation_2 <= 32.0;
	Compare_3 = accumulation <= 36;
	Compare_4 = Add_1 <= 32.0;
	sinus = sin(wt);
	rising = previos < Compare;
	offset = sinus + 1;
	amplitude = offset * scale;
	const double Product = Add_1 * Compare_4;
	const double reset = accumulation_1 * Compare_1;
	const double reset_1 = accumulation * Compare_3;
	const double reset_2 = accumulation_2 * Compare_2;
	accumulation_3 = rising + UnitDelay_1;
	const double amplitude_1 = reset_2 * AnalogInput_Amp_cfunc_symbols.amplitude;
	duty = 18 >= reset_1;
	arduino_dds_S.direction_state = ((reset >= 32) || ((!(reset <= 0)) && arduino_dds_S.direction_state));
	if (arduino_dds_S.direction_state) {
		direction = 1.0;
	} else {
		direction = 0.0;
	}
	down = 64.0 - reset;
	Add = 32.0 - Product;
	const double amplitude_2 = duty * scale_1;
	const double Product_1 = Add * AnalogInput_Amp_cfunc_symbols.amplitude;
	Compare_5 = accumulation_3 <= 4;
	if (direction > 0.0) {
		change = down;
	} else {
		change = reset;
	}
	const double amplitude_3 = change * AnalogInput_Amp_cfunc_symbols.amplitude;
	const double reset_3 = accumulation_3 * Compare_5;
	switch((int32_t)reset_3) {
		case 0:
		 MultiportSwitch = amplitude_1;
		 break;
		case 1:
		 MultiportSwitch = Product_1;
		 break;
		case 2:
		 MultiportSwitch = amplitude_3;
		 break;
		case 3:
		 MultiportSwitch = amplitude;
		 break;
		default:
		 MultiportSwitch = amplitude_2;
		 break;
	}
	HRPWM_Output_cfunc_symbols_t HRPWM_Output_cfunc_symbols = {
		MultiportSwitch,
	};
	HRPWM_Output_cfunc(&HRPWM_Output_cfunc_symbols, &HRPWM_Output_cfunc_params);
	arduino_dds_S.UnitDelay_state = reset;
	arduino_dds_S.UnitDelay_1_state = reset_3;
	arduino_dds_S.UnitDelay_1_1_state = reset_1;
	arduino_dds_S.previos_state = Compare;
	arduino_dds_S.UnitDelay_2_state = reset_2;
	arduino_dds_S.UnitDelay_3_state = Product;
	arduino_dds_S.counter_state += 0.0005 * AnalogInput_Freq_cfunc_symbols.frequency;

}
