# This is a verification script for the arduino_dds generated code.
# Run this code in order to create a verification model with a CFunction block inside that behaves like the original model.

# CFunction variables
output_code = """
arduino_dds_step();
"""
start_code = "arduino_dds_init();"
terminate_code = "arduino_dds_term();"

# Close
try engee.close("arduino_dds_verification";force=true) catch end
# Create
engee.create("arduino_dds_verification")
# Add Blocks
engee.add_block("/Basic/User-Defined Functions/C Function", "arduino_dds_verification/")
# Edit block parameters
engee.set_param!("arduino_dds_verification/C Function", "OutputCode" => output_code, "StartCode" => start_code, "TerminateCode" => terminate_code)
engee.set_param!("arduino_dds_verification/C Function", "Inputs" => 0)
engee.set_param!("arduino_dds_verification/C Function", "Outputs" => 0)
engee.set_param!("arduino_dds_verification/C Function", "SampleTime" => "0.0005")
engee.set_param!("arduino_dds_verification/C Function", "SourceFiles" => "/user/start/examples/codegen/arduino_dds/arduino_dds_code/arduino_dds.c")
engee.set_param!("arduino_dds_verification/C Function", "IncludeDirectories" => "/user/start/examples/codegen/arduino_dds/arduino_dds_code/")
engee.set_param!("arduino_dds_verification/C Function", "Headers" => "stdint.h math.h arduino_dds.h")
# Edit model parameters
engee.set_param!("arduino_dds_verification", "FixedStep" => 0.0005)
engee.set_param!("arduino_dds_verification", "StartTime" => 0.0)
engee.set_param!("arduino_dds_verification", "StopTime" => 1)
engee.set_param!("arduino_dds_verification", "EnableMultiTasking" => false)
# Add lines
# Save
engee.save("arduino_dds_verification.engee"; force=true)
